//////////////////////
// Window Procedure //
//////////////////////
extern LRESULT CALLBACK WindowProcedure( HWND NineWindow, UINT uMessage, WPARAM wparam, LPARAM lparam )
{
	switch(uMessage)
	{
		case WM_KEYDOWN:
		{
			switch(wparam)
			{
				case VK_ESCAPE:	
				{
					PostMessage( NineWindow, WM_CLOSE, 0, 0 );
					return false;
					break;
				}

				case VK_F1:	
					{ controls.F1 *= -1 ; }	break;
				case VK_F2:	
					{ controls.F2 *= -1 ; }	break;
				case VK_F3:	
					{ controls.F3 *= -1 ; }	break;
				case VK_F4:	
					{ controls.F4 *= -1 ; }	break;
				case VK_F5:	
					{ controls.F5 *= -1 ; }	break;
				case VK_F6:	
					{ controls.F6 *= -1 ; }	break;
				case VK_F7:	
					{ controls.F7 *= -1 ; }	break;
				case VK_F8:	
					{ controls.F8 *= -1 ; }	break;
				case VK_F9:	
					{ controls.F9 *= -1 ; }	break;
				case VK_UP:	
					{ 
						if ( ACCURACY < 800 )
						{
							D3DDevice->BeginScene();
							D3DDevice->SetVertexShader( CUSTOM_VERTEX_RHW );
							D3DDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, shape_rhw, sizeof(VERTEX_RHW) );
							_stprintf( infodisplay, _T("Calculating...") );
							font->DrawText( 2,  0, D3DCOLOR_XRGB(255,255,255), infodisplay );
							D3DDevice->Present( NULL, NULL, NULL, NULL );
							D3DDevice->EndScene();
							
							ACCURACY++ ;
							pathfinder.initialize( imagename );
						}
						break;
					}	
				case VK_DOWN:	
					{ 
						if ( ACCURACY > 1 )
						{
							D3DDevice->BeginScene();
							D3DDevice->SetVertexShader( CUSTOM_VERTEX_RHW );
							D3DDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, shape_rhw, sizeof(VERTEX_RHW) );
							_stprintf( infodisplay, _T("Calculating...") );
							font->DrawText( 2,  0, D3DCOLOR_XRGB(255,255,255), infodisplay );
							D3DDevice->Present( NULL, NULL, NULL, NULL );
							D3DDevice->EndScene();
							
							ACCURACY--;
							pathfinder.initialize( imagename );
						}
						break;
					}	
				case VK_LEFT:	
					{ 
						if ( CURRENTIMAGE > 0 )
						{
							D3DDevice->BeginScene();
							D3DDevice->SetVertexShader( CUSTOM_VERTEX_RHW );
							D3DDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, shape_rhw, sizeof(VERTEX_RHW) );
							_stprintf( infodisplay, _T("Calculating...") );
							font->DrawText( 2,  0, D3DCOLOR_XRGB(255,255,255), infodisplay );
							D3DDevice->Present( NULL, NULL, NULL, NULL );
							D3DDevice->EndScene();
							
							CURRENTIMAGE--;
							imagename = "images/hittest\0";
							imagename += _itoa( CURRENTIMAGE, stringconvertbuffer, 10 );
							imagename += ".bmp";
							pathfinder.initialize( imagename );
						}
						break;
					}
				case VK_RIGHT:	
					{ 
						if ( CURRENTIMAGE < 3 )
						{
							D3DDevice->BeginScene();
							D3DDevice->SetVertexShader( CUSTOM_VERTEX_RHW );
							D3DDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, shape_rhw, sizeof(VERTEX_RHW) );
							_stprintf( infodisplay, _T("Calculating...") );
							font->DrawText( 2,  0, D3DCOLOR_XRGB(255,255,255), infodisplay );
							D3DDevice->Present( NULL, NULL, NULL, NULL );
							D3DDevice->EndScene();
							
							CURRENTIMAGE++;
							imagename = "images/hittest\0";
							imagename += _itoa( CURRENTIMAGE, stringconvertbuffer, 10 );
							imagename += ".bmp";
							pathfinder.initialize( imagename );
						}
						break;
					}
				case VK_END:	
					{ 
						if ( HEURISTIC > 0 )
							HEURISTIC--;
						break;
					}
				case VK_HOME:	
					{ 
						if ( HEURISTIC < 10 )
							HEURISTIC++;
						break;
					}
			}
			break;
		}

		case WM_MOUSEMOVE :
		{
			mouse.x = LOWORD ( lparam ) ;
			mouse.y = HIWORD ( lparam ) ;
			 break;
		}
		case WM_LBUTTONDOWN :
		{
			if ( mouse.LMB == 1 )
				mouse.LMB = 0;
			else
				mouse.LMB = 1;
			sourcex = (float)mouse.x;
			sourcey = (float)mouse.y;
			break;
		} 
		case WM_LBUTTONUP :
		{
			//mouse.LMB = 0;
			break;
		}
		case WM_RBUTTONDOWN :
		{
			mouse.RMB = 1;
			destx = (float)mouse.x;
			desty = (float)mouse.y;
			break;
		} 
		case WM_RBUTTONUP :
		{
			mouse.RMB = 0;
			break;
		} 


		case WM_DESTROY:
		{
			RUNNING = false;
			PostQuitMessage(0);
			return false;
			break;
		}
	
	}

	return DefWindowProc( NineWindow, uMessage, wparam, lparam );
}


///////////////////
// CREATE WINDOW //
///////////////////
void createwindow()
{
	WindowClass.hInstance		= GetModuleHandle(NULL);
	WindowClass.lpszClassName	= "Pathfinder";
	WindowClass.lpfnWndProc		= WindowProcedure;
	WindowClass.style			= CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS | CS_OWNDC ;
	WindowClass.hIcon			= LoadIcon( NULL, MAKEINTRESOURCE(IDI_ICON1) );
	WindowClass.hIconSm			= NULL;
	WindowClass.hCursor			= LoadCursor( NULL, IDC_CROSS );
	WindowClass.lpszMenuName	= NULL;
	WindowClass.cbClsExtra		= 0;
	WindowClass.cbWndExtra		= 0;
	WindowClass.cbSize			= sizeof ( WNDCLASSEX );
	WindowClass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);

	RegisterClassEx( &WindowClass );

	RECT rc;
	SetRect( &rc, 0, 0, 800, 600 );
	AdjustWindowRect( &rc, WS_SYSMENU, true );

	Window = CreateWindow(	"Pathfinder",
							"Pathfinder",
							WS_SYSMENU,
							CW_USEDEFAULT, 
							CW_USEDEFAULT, 
							(rc.right - rc.left), 
							(rc.bottom - rc.top), 
							HWND_DESKTOP, 
							NULL,
							GetModuleHandle(NULL), 
							NULL );


}


/////////////
// INITD3D //
/////////////
void initD3D()
{
	D3DObject = Direct3DCreate8 ( D3D_SDK_VERSION );

	D3DObject->GetAdapterIdentifier ( 0, 0, &D3DAdapterInfo );
	D3DObject->GetAdapterDisplayMode( 0, &D3DCurrentDisplayMode );

	D3DPresentParameters.BackBufferFormat					= ( D3DCurrentDisplayMode.Format );
	D3DPresentParameters.BackBufferCount					= 1;
	D3DPresentParameters.BackBufferWidth					= 800;
	D3DPresentParameters.BackBufferHeight					= 600;
	D3DPresentParameters.SwapEffect							= D3DSWAPEFFECT_COPY;
	D3DPresentParameters.EnableAutoDepthStencil				= FALSE;
	D3DPresentParameters.AutoDepthStencilFormat				= D3DFMT_UNKNOWN;
	D3DPresentParameters.FullScreen_RefreshRateInHz			= D3DPRESENT_RATE_DEFAULT;
	D3DPresentParameters.FullScreen_PresentationInterval	= D3DPRESENT_INTERVAL_DEFAULT;
	D3DPresentParameters.MultiSampleType					= D3DMULTISAMPLE_NONE;
	D3DPresentParameters.Windowed							= FALSE;
	D3DPresentParameters.hDeviceWindow						= Window;
	D3DPresentParameters.Flags								= 0;

	D3DViewport.Width	= WORLDWIDTH;
	D3DViewport.Height	= WORLDHEIGHT;
	D3DViewport.X		= 0;
	D3DViewport.Y		= 0;
	D3DViewport.MinZ	= -5.0f;
	D3DViewport.MaxZ	= 5.0f;

	D3DObject->CreateDevice(	D3DADAPTER_DEFAULT, 
								D3DDEVTYPE_HAL, 
								Window, 
								D3DCREATE_SOFTWARE_VERTEXPROCESSING, 
								&D3DPresentParameters, 
								&D3DDevice );

	D3DDevice->SetViewport( &D3DViewport );



	////////////////////////
	// Set-up font object //
	////////////////////////
	font = new CD3DFont( _T("Arial"), 8 );
	font->InitDeviceObjects( D3DDevice );
	font->RestoreDeviceObjects();
	
	controls.F1 = 1;
	controls.F2 = 1;
	controls.F3 = -1;
	controls.F4 = -1;
	controls.F5 = -1;
	controls.F6 = -1;
	controls.F7 = -1;
	controls.F8 = -1;
	controls.F9 = -1;

	shape_rhw[0].x = 0;
	shape_rhw[0].y = 0;
	shape_rhw[1].x = 130;
	shape_rhw[1].y = 0;
	shape_rhw[2].x = 130;
	shape_rhw[2].y = 155;
	shape_rhw[3].x = 0;
	shape_rhw[3].y = 155;
	shape_rhw[0].diffuse = D3DCOLOR_ARGB(100,0,0,0);
	shape_rhw[1].diffuse = D3DCOLOR_ARGB(100,0,0,0);
	shape_rhw[2].diffuse = D3DCOLOR_ARGB(100,0,0,0);
	shape_rhw[3].diffuse = D3DCOLOR_ARGB(100,0,0,0);
}

/////////////////////////////////////////////////////