#include "main.h"

/////////////
// WinMain //
/////////////
int WINAPI WinMain( HINSTANCE hThisInst, HINSTANCE hPrevInst, LPSTR lpszArgs, int nWinMode )
{
	destx = 0;
	desty = 0;

	// SET-UP FUNCTIONS ////////////////////
	createwindow		 ();
	initD3D				 ();
	ShowWindow			 ( Window, nWinMode );

	infodisplay[0];

	QueryPerformanceFrequency( ( LARGE_INTEGER * ) &tick );

	imagename += "images/hittest0.bmp";
	pathfinder.initialize( imagename );

	MSG Message;
	PeekMessage( &Message, NULL, 0, 0, PM_REMOVE );
	///////////////////////////////////////////////////////////////////



	dot.rhw		= 1;
	dot.z		= 1;
	dot.diffuse = D3DCOLOR_XRGB( 255, 255, 255 );

	line[0].rhw = 1;
	line[1].rhw = 1;
	line[0].z   = 1;
	line[1].z   = 1;
	line[0].diffuse = D3DCOLOR_XRGB( 255, 0, 0 );
	line[1].diffuse = D3DCOLOR_XRGB( 255, 0, 0 );



	// MAIN LOOP /////////////////////////////////////////////////////////////////////////
	while(RUNNING)
	{
		if( PeekMessage( &Message, NULL, 0, 0, PM_REMOVE ) )
		{
			TranslateMessage(&Message);
			DispatchMessage(&Message);
		}
		render();
	}
	////////////////////////////////////////////////////////////////////////////////////////


	// CLEAN-UP ///////////////////////////////////////////////
	if(D3DDevice != NULL)
	{
		D3DDevice->Release();
		D3DDevice = NULL;
	}

	if(D3DObject != NULL)
	{
		D3DObject->Release();
		D3DObject = NULL;
	}
	UnregisterClass( "Pathfinder", GetModuleHandle(NULL) );

	return 0;
	///////////////////////////////////////////////////////////
}






////////////
// render //
////////////
void render()
{

	D3DDevice->Clear( NULL, NULL, D3DCLEAR_TARGET, 0, 0.0f, 0 );


	D3DDevice->BeginScene		();


	pathfinder.findpath( (int)destx/ACCURACY, (int)desty/ACCURACY, (int)mouse.x/ACCURACY, (int)mouse.y/ACCURACY );


	// Draw background
	if ( controls.F1 == 1)
	{
		D3DDevice->GetBackBuffer ( 0 , D3DBACKBUFFER_TYPE_MONO , &pBackBuffer );
		D3DDevice->CopyRects( image, &rect, 1, pBackBuffer, 0 );
		pBackBuffer->Release();
	}

	// Draw nodes
	if ( controls.F4 == 1 || controls.F5 == 1 )
	{
		for ( UINT i = 0; i < WORLDWIDTH/ACCURACY; i++ )
		{
			for ( UINT j = 0; j < WORLDHEIGHT/ACCURACY; j++ )
			{
				if ( pathfinder.graph[i][j].blocked == 0 )
				{
					dot.x = (float)i * ACCURACY;
					dot.y = (float)j * ACCURACY;

					if ( controls.F4 == 1 )
					{
						dot.diffuse = D3DCOLOR_XRGB( 100, 100, 100 );
						D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );
					}

					if ( pathfinder.graph[i][j].visited == 1 && controls.F5 == 1 )
					{
						dot.diffuse = D3DCOLOR_XRGB( 255, 100, 40 );
						D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );

						dot.diffuse = D3DCOLOR_XRGB( 140, 20, 0 );

						dot.x = ((float)i * ACCURACY) + 1;
						dot.y = ((float)j * ACCURACY);
						D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );

						dot.x = ((float)i * ACCURACY) - 1;
						dot.y = ((float)j * ACCURACY);
						D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );

						dot.x = ((float)i * ACCURACY);
						dot.y = ((float)j * ACCURACY) + 1;
						D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );

						dot.x = ((float)i * ACCURACY);
						dot.y = ((float)j * ACCURACY) - 1;
						D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );
					}

				}
			}
		}
	}



	// Draw lines
	if ( controls.F2 == 1 )
	{
		for ( int i = 0; pathfinder.waypoints[i+1].x != NULL; i++ )
		{
			line[0].x = (float)pathfinder.waypoints[i].x * ACCURACY;
			line[0].y = (float)pathfinder.waypoints[i].y * ACCURACY;
			line[1].x = (float)pathfinder.waypoints[i+1].x * ACCURACY;
			line[1].y = (float)pathfinder.waypoints[i+1].y * ACCURACY;
			line[0].diffuse = D3DCOLOR_XRGB( 255, 255, 255 );
			line[1].diffuse = D3DCOLOR_XRGB( 0, 0, 255 );
			D3DDevice->DrawPrimitiveUP( D3DPT_LINELIST, 1, line, sizeof( VERTEX_RHW ) );
		}

	}
	// Draw waypoints
	if (  controls.F3 == 1 )
	{
		for ( int i = 0; pathfinder.waypoints[i].x != NULL; i++ )
		{
			dot.x = (float)pathfinder.waypoints[i].x * ACCURACY;
			dot.y = (float)pathfinder.waypoints[i].y * ACCURACY;
			dot.diffuse = D3DCOLOR_XRGB( 0, 255,0 )	 ;

			D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );
			dot.x = (float)(pathfinder.waypoints[i].x * ACCURACY) + 1;
			dot.y = (float)(pathfinder.waypoints[i].y * ACCURACY) + 1;
			D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );
			dot.x = (float)(pathfinder.waypoints[i].x * ACCURACY) + 1;
			dot.y = (float)(pathfinder.waypoints[i].y * ACCURACY) - 1;
			D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );
			dot.x = (float)(pathfinder.waypoints[i].x * ACCURACY) - 1;
			dot.y = (float)(pathfinder.waypoints[i].y * ACCURACY) - 1;
			D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );
			dot.x = (float)(pathfinder.waypoints[i].x * ACCURACY) - 1;
			dot.y = (float)(pathfinder.waypoints[i].y * ACCURACY) + 1;
			D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );

			dot.x = (float)(pathfinder.waypoints[i].x * ACCURACY) + 2;
			dot.y = (float)(pathfinder.waypoints[i].y * ACCURACY) + 2;
			D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );
			dot.x = (float)(pathfinder.waypoints[i].x * ACCURACY) + 2;
			dot.y = (float)(pathfinder.waypoints[i].y * ACCURACY) - 2;
			D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );
			dot.x = (float)(pathfinder.waypoints[i].x * ACCURACY) - 2;
			dot.y = (float)(pathfinder.waypoints[i].y * ACCURACY) - 2;
			D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );
			dot.x = (float)(pathfinder.waypoints[i].x * ACCURACY) - 2;
			dot.y = (float)(pathfinder.waypoints[i].y * ACCURACY) + 2;
			D3DDevice->DrawPrimitiveUP( D3DPT_POINTLIST, 1, &dot, sizeof( VERTEX_RHW ) );
		}
	}



   // Draw UI ////////////////////////////////////////////////////////////////////////////////////////
	D3DDevice->SetVertexShader( CUSTOM_VERTEX_RHW );
	D3DDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, shape_rhw, sizeof(VERTEX_RHW) );

	line[0].diffuse = D3DCOLOR_XRGB( 255, 255, 255 );
	line[1].diffuse = D3DCOLOR_XRGB( 255, 255, 255 );

	line[0].x = 128;
	line[0].y = 0;
	line[1].x = 128;
	line[1].y = 153;
	D3DDevice->DrawPrimitiveUP( D3DPT_LINELIST, 1, line, sizeof( VERTEX_RHW ) );

	line[0].x = 128;
	line[0].y = 153;
	line[1].x = 0;
	line[1].y = 153;
	D3DDevice->DrawPrimitiveUP( D3DPT_LINELIST, 1, line, sizeof( VERTEX_RHW ) );

	line[0].x = 0;
	line[0].y = 0;
	line[1].x = 799;
	line[1].y = 0;
	D3DDevice->DrawPrimitiveUP( D3DPT_LINELIST, 1, line, sizeof( VERTEX_RHW ) );
	line[0].x = 799;
	line[0].y = 0;
	line[1].x = 799;
	line[1].y = 599;
	D3DDevice->DrawPrimitiveUP( D3DPT_LINELIST, 1, line, sizeof( VERTEX_RHW ) );
	line[0].x = 799;
	line[0].y = 599;
	line[1].x = 0;
	line[1].y = 599;
	D3DDevice->DrawPrimitiveUP( D3DPT_LINELIST, 1, line, sizeof( VERTEX_RHW ) );
	line[0].x = 0;
	line[0].y = 599;
	line[1].x = 0;
	line[1].y = 0;
	D3DDevice->DrawPrimitiveUP( D3DPT_LINELIST, 1, line, sizeof( VERTEX_RHW ) );



	_stprintf( infodisplay, _T("Path time: %0.3fsec"), (float)((end_time - start_time) / (float)tick) );
							font->DrawText( 4,  2, D3DCOLOR_XRGB(255,255,255), infodisplay );
	_stprintf( infodisplay, _T("F1: Image") );
	if ( controls.F1 == 1 )	font->DrawText( 4,  22, D3DCOLOR_XRGB(255,255,255), infodisplay );
	else					font->DrawText( 4,  22, D3DCOLOR_XRGB(120,120,120), infodisplay );
	_stprintf( infodisplay, _T("F2: Lines") );
	if ( controls.F2 == 1 )	font->DrawText( 4,  37, D3DCOLOR_XRGB(255,255,255), infodisplay );
	else					font->DrawText( 4,  37, D3DCOLOR_XRGB(120,120,120), infodisplay );
	_stprintf( infodisplay, _T("F3: Waypoints") );
	if ( controls.F3 == 1 )	font->DrawText( 4,  52, D3DCOLOR_XRGB(255,255,255), infodisplay );
	else					font->DrawText( 4,  52, D3DCOLOR_XRGB(120,120,120), infodisplay );
	_stprintf( infodisplay, _T("F4: Nodes") );
	if ( controls.F4 == 1 )	font->DrawText( 4,  67, D3DCOLOR_XRGB(255,255,255), infodisplay );
	else					font->DrawText( 4,  67, D3DCOLOR_XRGB(120,120,120), infodisplay );
	_stprintf( infodisplay, _T("F5: Visited Nodes") );
	if ( controls.F5 == 1 )	font->DrawText( 4,  82, D3DCOLOR_XRGB(255,255,255), infodisplay );
	else					font->DrawText( 4,  82, D3DCOLOR_XRGB(120,120,120), infodisplay );
	_stprintf( infodisplay, _T("F6: Straight line check"), (int)FILTERITER );
	if ( controls.F6 == 1 )	font->DrawText( 4,  97, D3DCOLOR_XRGB(255,255,255), infodisplay );
	else					font->DrawText( 4,  97, D3DCOLOR_XRGB(120,120,120), infodisplay );
	_stprintf( infodisplay, _T("F7: Advandced Filtering"), (int)FILTERITER );
	if ( controls.F7 == 1 )	font->DrawText( 4,  112, D3DCOLOR_XRGB(255,255,255), infodisplay );
	else					font->DrawText( 4,  112, D3DCOLOR_XRGB(120,120,120), infodisplay );

	_stprintf( infodisplay, _T("Heuristic Weight x%d"), (int)HEURISTIC );
							font->DrawText( 4,  132, D3DCOLOR_XRGB(255,255,255), infodisplay );

	////////////////////////////////////////////////////////////////////////////////////////////////////


	D3DDevice->Present( NULL, NULL, NULL, NULL );
	D3DDevice->EndScene			();
	

	if ( COUNTER < 100 ) COUNTER++;
	else				 COUNTER = 0;


}

#include "definitions.h"