#include <iostream>
#include <windows.h>
#include <math.h>
#include <atlstr.h>
#include <vector>

#include <d3d8.h>
#include <d3dx8.h>
#include <D3dx8tex.h>
#include "DXUtils/D3DFont.h"
#include "DXUtils/DXUtil.h"
#include "DXUtils/D3DUtil.h"

#include "resource.h"


using namespace std;


IDirect3DSurface8* ImageSurfaceFromBMP ( IDirect3DDevice8* pDevice , LPCTSTR FileName , D3DFORMAT format ) ;
void GetFormatName  ( D3DFORMAT Format , char* FormatName ) ;
UINT GetFormatRBits ( D3DFORMAT Format ) ;	//red
UINT GetFormatGBits ( D3DFORMAT Format ) ;	//green
UINT GetFormatBBits ( D3DFORMAT Format ) ;	//blue
UINT GetFormatABits ( D3DFORMAT Format ) ;	//alpha
UINT GetFormatDBits ( D3DFORMAT Format ) ;	//depth
UINT GetFormatSBits ( D3DFORMAT Format ) ;	//stencil
UINT GetFormatXBits ( D3DFORMAT Format ) ;  //unused bits
UINT GetFormatRMask ( D3DFORMAT Format ) ;	//red
UINT GetFormatGMask ( D3DFORMAT Format ) ;	//green
UINT GetFormatBMask ( D3DFORMAT Format ) ;	//blue
UINT GetFormatAMask ( D3DFORMAT Format ) ;	//alpha
UINT GetFormatDMask ( D3DFORMAT Format ) ;	//depth
UINT GetFormatSMask ( D3DFORMAT Format ) ;	//stencil

// FUNCTION PROTOTYPES ////////////////////////////////////////////////////////////
LRESULT CALLBACK WindowProcedure( HWND, UINT, WPARAM, LPARAM );

void		render						();

void		createwindow				();
void		initD3D						();
void		resetworldmatrix			();
void		setupworldmatrix			( const float*	x, 
										  const float*	y, 
										  const float*	rotation );

////////////////////////////////////////////////////////////////////////////////////


#include "custom_data_types.h"


// GLOBALS /////////////////////////////////////////////////////////////
	bool						RUNNING			= true;

	UINT						COUNTER			= 0;
	float						sourcex			= 0;
	float						sourcey			= 0;
	float						destx			= 0;
	float						desty			= 0;

	CONTROLS					controls;
	UINT						CURRENTIMAGE	= 0;
	UINT						ACCURACY		= 10;
	UINT						FILTERITER		= 0;
	UINT						HEURISTIC		= 0;
	

	LONGLONG					start_time		= 0;
	LONGLONG					end_time		= 0;
	LONGLONG					tick			= 0;

	VERTEX_RHW					shape_rhw	[4];

	D3DXIMAGE_INFO				info;
	CD3DFont*					font;
	TCHAR						infodisplay[90];
	CString						imagename;
	char						stringconvertbuffer[40];


	// CUSTOM OBJECTS ////////////////////////
	MOUSE						mouse;
	PATHFINDER					pathfinder;
	//////////////////////////////////////////


	// GLOBAL RENDERFLAGS
	RENDERFLAGS				RF_NORMAL;
	RENDERFLAGS				RF_NORMAL_A;

	// DISPLAY OBJECTS /////////////////////////
	IDirect3DSurface8*			image;
	IDirect3DSurface8*			pBackBuffer ;
	RECT						rect;

	VERTEX_RHW					dot;
	VERTEX_RHW					line[2];

	////////////////////////////////////////////

	// INIT VARIABLES ////////////////////////////////
	WNDCLASSEX					WindowClass;
	HWND						Window;
	HRESULT						hr;
	IDirect3D8*					D3DObject;				
	IDirect3DDevice8*			D3DDevice;
	D3DPRESENT_PARAMETERS		D3DPresentParameters;
	D3DVIEWPORT8				D3DViewport;
	D3DADAPTER_IDENTIFIER8		D3DAdapterInfo;
	D3DDISPLAYMODE				D3DCurrentDisplayMode;
	//////////////////////////////////////////////////
	
////////////////////////////////////////////////////////////////////////