#define WORLDWIDTH  800
#define WORLDHEIGHT 600

struct CELL
{
	UINT blocked : 1;
	UINT visited : 1;
};


struct PATHNODE
{
	UINT xref;
	UINT yref;
	UINT g;
	UINT h;
	UINT f; 
	PATHNODE* parent;
};

struct WAYPOINT
{
	UINT x;
	UINT y;
};



class PATHFINDER
{
public:
	 PATHFINDER();
	~PATHFINDER();

	void		initialize	( CString );
	int			round		( float );
	bool		hittest		( int x, int y );
	bool		straightline( int, int, int, int );
	WAYPOINT*	findpath	( int sx, int sy, int dx, int dy );

	CELL		graph[WORLDWIDTH][WORLDHEIGHT];					// Array of 'CELL's to store hittest information
	WAYPOINT	waypoints[1000];								// Array to store return waypoint values
	WAYPOINT	buffer[1000];
private:

	int			PATHFINDER::GoalDistEstimate	( int sx, int sy, int dx, int dy );
	PATHNODE*	getnode							();
	void		filterwaypoints					();

	HDC			hittest_hdc;
	HBITMAP		hittest_bitmap;
	PATHNODE*	temp;

	bool		straight;
	UINT		DEPTH;
	UINT		lowestscore;
	UINT		lowestindex;
	UINT		i;
	UINT		j;
	UINT		k;
	UINT		left;
	UINT		right;
	UINT		top;
	UINT		bottom;
	UINT		index;

	vector<PATHNODE*>::iterator		iter;
	vector<PATHNODE*>				openlist;
	vector<PATHNODE*>				closedlist;
	vector<PATHNODE*>				cache;

	PATHNODE*	current;
	PATHNODE*	start;

};







	





